#define EXTERN
#include "EATME.h"


#define MAXBLOCKS 9000
static HANDLE hList[MAXBLOCKS];
static int nListCount= -1;
static long nBytesTotal=0L;


static void UnlockAll()
{
int n = nListCount;

   while (n >= 0)
      GlobalUnlock(hList[n--]);
}

static void LockAll()
{
int n = nListCount;
int failed=0;

   while (n >= 0)
      if (GlobalLock(hList[n--]) == NULL)
            failed++;

   if (failed)
   {
      MessageBox(GetFocus(),"Failed on one or more locks","ERROR!",MB_ICONEXCLAMATION | MB_OK);
      UnlockAll();
   }
}


static void FreeAllBlocks()
{
   nBytesTotal = 0L;

   while (nListCount >= 0)
   {
      GlobalFree(hList[nListCount]);
      hList[nListCount] = (HANDLE)NULL;
      nListCount--;
   }

   InvalidateRect(hWndMain,NULL,TRUE);
}


static int AllocateBlocks(unsigned nBlocks, unsigned nBlockSize)
{
static int nCount = 0;

   if (nBlocks + nListCount >= MAXBLOCKS)
   {
      MessageBox(GetFocus(),"Too many blocks!","Sorry!",MB_ICONEXCLAMATION | MB_OK);
      return(0);
   }

   while (nBlocks--)
   {
      if (nListCount >= MAXBLOCKS)
      {
         MessageBox(GetFocus(),"You have reached my humble limit!","Too Many Block!",MB_ICONEXCLAMATION | MB_OK);
         break;
      }

      if (!(hList[++nListCount] = GlobalAlloc(GMEM_MOVEABLE,(DWORD)nBlockSize)))
      {
         MessageBox(GetFocus(),"Could not allocate all requested memory!","ERROR!!",MB_ICONEXCLAMATION | MB_OK);
         nListCount--;
         break;
      }      

      nBytesTotal += (long)nBlockSize;
   }

   InvalidateRect(hWndMain,NULL,TRUE);
   return(nBlocks);
}

/************************************************************************/
/*                                                                      */
/* Windows 3.0 Main Program Body                                        */
/*                                                                      */
/* The following routine is the Windows Main Program.  The Main Program */
/* is executed when a program is selected from the Windows Control      */
/* Panel or File Manager.  The WinMain routine registers and creates    */
/* the program's main window and initializes global objects.  The       */
/* WinMain routine also includes the applications message dispatch      */
/* loop.  Every window message destined for the main window or any      */
/* subordinate windows is obtained, possibly translated, and            */
/* dispatched to a window or dialog processing function. The dispatch   */
/* loop is exited when a WM_QUIT message is obtained.  Before exiting   */
/* the WinMain routine should destroy any objects created and free      */
/* memory and other resources.                                          */
/*                                                                      */
/************************************************************************/

int PASCAL WinMain(hInstance, hPrevInstance, lpszCmdLine, nCmdShow)
HANDLE hInstance;       /* handle for this instance                     */
HANDLE hPrevInstance;   /* handle for possible previous instances       */
LPSTR  lpszCmdLine;     /* long pointer to exec command line            */
int    nCmdShow;        /* Show code for main window display            */
{
     MSG      msg;          /* MSG structure to store your messages         */
     int      rc;

     hInst = hInstance;

     if (!hPrevInstance)
     {
          /* register window classes if first instance of application         */
          if(rc = RegisterClasses())
          {
               /* registering one of the windows failed                         */       
               LoadString(hInst, IDS_ERR_REGISTER_CLASS, string, sizeof(string));
               MessageBox(NULL, string, NULL, MB_ICONEXCLAMATION);
               return(rc);    
          }
     }

     /* create application's Main window                                    */
     hWndMain = CreateWindow(
       szAppName,               /* Window class name           */
       "Memory Hog",            /* Window's title              */
       WS_CAPTION      |        /* Title and Min/Max           */
       WS_SYSMENU      |        /* Add system menu box         */
       WS_MINIMIZEBOX  |        /* Add minimize box            */
       WS_MAXIMIZEBOX  |        /* Add maximize box            */
       WS_THICKFRAME   |        /* thick sizeable frame        */
       WS_VISIBLE      |        /* window created visible      */
       WS_CLIPCHILDREN,         /* don't draw in child windows areas */
       CW_USEDEFAULT, 0,        /* Use default X, Y            */
       CW_USEDEFAULT, 0,        /* Use default width, height   */
       NULL,                    /* Parent window's handle      */
       NULL,                    /* default to class menu       */
       hInst,                   /* Instance of window          */
       NULL);                   /* Create struct for WM_CREATE */

     if(hWndMain == NULL)
     {
          LoadString(hInst, IDS_ERR_CREATE_WINDOW, string, sizeof(string));
          MessageBox(NULL, string, NULL, MB_ICONEXCLAMATION);
          return(IDS_ERR_CREATE_WINDOW);
     }

     ShowWindow(hWndMain, nCmdShow);            /* display main window      */

     while(GetMessage(&msg, NULL, 0, 0))        /* Until WM_QUIT message    */
     {
          TranslateMessage(&msg);
          DispatchMessage(&msg);
     }
     return(msg.wParam);
} /*  End of WinMain  */



/************************************************************************/
/*                                                                      */   
/* Main Window Procedure                                                */
/*                                                                      */
/* This procedure provides service routines for the Windows events      */
/* (messages) that Windows sends to the window, as well as the user     */
/* initiated events (messages) that are generated when the user selects */
/* the action bar and pulldown menu controls or the corresponding       */
/* keyboard accelerators.                                               */
/*                                                                      */
/* The SWITCH statement shown below distributes the window messages to  */
/* the respective message service routines, which are set apart by the  */
/* CASE statements. The window procedures must provide an appropriate   */
/* service routine for its end user initiated messages, as well as the  */
/* general Windows messages (ie. WM_CLOSE message). If a message is     */
/* sent to this procedure for which there is no programmed CASE clause  */
/* (i.e., no service routine), the message is defaulted to the          */
/* DefWindowProc function, where it is handled by Windows               */
/*                                                                      */
/************************************************************************/

LONG FAR PASCAL WndProc(hWnd, Message, wParam, lParam)
HWND hWnd;                       /* Window Handle                       */
WORD Message;                    /* Message to this Window              */
WORD wParam;                     /* Word Parameter                      */
LONG lParam;                     /* Long Parameter                      */
{
     HMENU       hMenu=0;            /* handle for the menu                 */
     HBITMAP     hBitmap=0;          /* handle for bitmaps                  */                              
     HDC         hDC;                /* handle for the display device       */
     HANDLE      hPen=0;             /* handle for the current pen          */
     PAINTSTRUCT ps;                 /* holds PAINT information             */
     TEXTMETRIC  tm;                 /* holds information about fonts       */
     int         rc=0;               /* return code                         */
     char        szMsg[80];

     memset(&ps, 0x00, sizeof(PAINTSTRUCT));
     memset(&tm, 0x00, sizeof(TEXTMETRIC));

     switch (Message)
     {
     case WM_COMMAND:
          /* The Windows messages for action bar and pulldown menu items */
          /* are processed here.                                         */

          switch (wParam)
          {
          case IDM_EAT:
               /* Place User Code to respond to the                   */         
               /* Menu Item Named "&Eat" here.                        */
               {
                    FARPROC lpfnEATMEMsgProc;

                    lpfnEATMEMsgProc = MakeProcInstance((FARPROC)EATMEMsgProc, hInst); 
                    rc = DialogBox(hInst, (LPSTR)"EATME", hWnd, lpfnEATMEMsgProc);
                    FreeProcInstance(lpfnEATMEMsgProc);
               }
               break; 

          case IDM_LOCK:
               LockAll();
               break;

          case IDM_UNLOCK:
               UnlockAll();
               break;

          case IDM_FREE:
               /* Place User Code to respond to the                   */         
               /* Menu Item Named "&Free" here.                       */
               FreeAllBlocks();
               break; 


          default:
               return(DefWindowProc(hWnd, Message, wParam, lParam));
               break;
          }
          break;        /* End of WM_COMMAND                             */

     case WM_CREATE:
          /* The WM_CREATE message is sent once to a window when the     */
          /* window is created.  The window procedure for the new window */
          /* receives this message after the window is created, but      */
          /* before the window becomes visible.                          */


          break;       /*  End of WM_CREATE                              */

     case WM_SIZE:
          /*  code for sizing client area                   */
          break;       /* End of WM_SIZE                                 */

     case WM_PAINT:
          /* code for the window's client area              */
          /* Obtain a handle to the device context                       */
          /* BeginPaint will sends WM_ERASEBKGND if appropriate          */
          hDC = BeginPaint(hWnd, &ps);
          wsprintf(szMsg,"%ld bytes in %u handles",nBytesTotal,nListCount+1);
          TextOut(hDC,10,10,szMsg,strlen(szMsg));
          /* Inform Windows painting is complete                         */
          EndPaint(hWnd, &ps);
          break;       /*  End of WM_PAINT                               */

     case WM_CLOSE:
          /* close the window                                 */
          /* Destroy child windows, modeless dialogs then this window    */
          FreeAllBlocks();
          DestroyWindow(hWnd);
          PostQuitMessage(0);    /* Quit the application                 */
          break;                 /* End of WM_CLOSE                      */

     default:
          /* For any message for which you don't specifically provide a  */
          /* service routine, you should return the message to Windows   */
          /* for default message processing.                             */
          return(DefWindowProc(hWnd, Message, wParam, lParam));
          break;     /* End of default                                   */
     } 
     return(0L);
}     /* End of WndProc                                         */
/************************************************************************/
/*                                                                      */
/* Dialog Window Procedure                                              */
/*                                                                      */
/* This procedure is associated with the dialog box that is included in */
/* the function name of the procedure. It provides the service routines */
/* for the events (messages) that occur because the end user operates   */
/* one of the dialog box's buttons, entry fields, or controls.          */
/*                                                                      */
/* The SWITCH statement in the function distributes the dialog box      */
/* messages to the respective service routines, which are set apart by  */
/* the CASE clauses. Like any other Windows window, the Dialog Window   */
/* procedures must provide an appropriate service routine for their end */
/* user initiated messages as well as for general messages (like the    */
/* WM_CLOSE message). If a message is sent to this procedure for        */
/* which there is no programmed CASE condition (no service routine),    */
/* the message is defaulted to the DefDlgProc function, where it is     */
/* handled by Windows.                                                  */
/*                                                                      */
/************************************************************************/

BOOL FAR PASCAL EATMEMsgProc(hWndDlg, Message, wParam, lParam)
HWND hWndDlg;
WORD Message;
WORD wParam;
LONG lParam;
{ 
     int    rc;
     HANDLE hCtl;
     static char szWorkBuf[64];
     static char *pchEndPtr;

     switch(Message)
     {
     case WM_INITDIALOG:
          cwCenter(hWndDlg, 0);
          /* initialize working variables                                */
          rc = 0;
          hCtl = 0;
          strcpy(szWorkBuf, "");
          pchEndPtr = 0;

          break; /* End of WM_INITDLG                                    */

     case WM_CLOSE:
          /* Closing the Dialog behaves the same as Cancel               */              
          PostMessage(hWndDlg, WM_COMMAND, IDCANCEL, 0L);
          break; /* End of WM_CLOSE                                      */

     case WM_COMMAND:
          switch(wParam)
          {
          case 104:
               /* Entry field variable: "nBlockSize"             */
               switch(HIWORD(lParam)) /* switch on Notification Code  */
               { 
               case EN_SETFOCUS:
                    /* Edit ctrl is receiving the focus */
                    break;

               case EN_KILLFOCUS:
                    /* Edit ctrl is losing the focus */
                    break;

               default:
                    /* Default other messages       */
                    return(FALSE);
                    break;
               }
               break;

          case 105:
               /* Entry field variable: "nBlockCount"            */
               switch(HIWORD(lParam)) /* switch on Notification Code  */
               { 
               case EN_SETFOCUS:
                    /* Edit ctrl is receiving the focus */
                    break;

               case EN_KILLFOCUS:
                    /* Edit ctrl is losing the focus */
                    break;

               default:
                    /* Default other messages       */
                    return(FALSE);
                    break;
               }
               break;

          case IDOK:
               {
                    /* Validate the field                                 */
                    char buffer[5];

                    GetDlgItemText(hWndDlg, 104, buffer, sizeof(buffer));
                    if(!cwNumericValidate(buffer)) 
                    {
                         PostMessage(hWndDlg, WM_FAILEDVALIDATE, GetDlgItem(hWndDlg, 104), 0L);  
                         break;
                    }
               }
               {
                    /* Validate the field                                 */
                    char buffer[4];

                    GetDlgItemText(hWndDlg, 105, buffer, sizeof(buffer));
                    if(!cwNumericValidate(buffer)) 
                    {
                         PostMessage(hWndDlg, WM_FAILEDVALIDATE, GetDlgItem(hWndDlg, 105), 0L);  
                         break;
                    }
               }

               /* Query the integer in the edit control and move the  */                  
               /* integer value into the dialog structure variable    */
               Eatme.nBlockSize = GetDlgItemInt(hWndDlg, 104, NULL, TRUE);
               GetDlgItemText(hWndDlg, 104, szWorkBuf, 50);

               if(!required(szWorkBuf, NULL))
               {
                    MessageBeep(0);
                    LoadString(hInst, IDS_REQ_FIELD, string, sizeof(string));
                    MessageBox(NULL, string, NULL, MB_ICONINFORMATION);
                    SetFocus(GetDlgItem(hWndDlg, 104));
                    break;
               }

               /* Query the integer in the edit control and move the  */                  
               /* integer value into the dialog structure variable    */
               Eatme.nBlockCount = GetDlgItemInt(hWndDlg, 105, NULL, TRUE);
               AllocateBlocks((unsigned)Eatme.nBlockCount,(unsigned)Eatme.nBlockSize);
               EndDialog(hWndDlg, TRUE);
               break;

          case IDCANCEL:
               /* Ignore data values entered into the controls        */
               /* and dismiss the dialog window returning FALSE       */
               EndDialog(hWndDlg, FALSE);
               break;

          }
          break;    /* End of WM_COMMAND                                 */

     case WM_FAILEDVALIDATE:
          /* used when an edit field fails validation */      
          MessageBeep(0);          
          SetFocus(wParam);        
          break;    /* End of WM_FAILEDVALIDATE                          */

     default:
          return (FALSE);
     }
     return(TRUE);
} /* End of EATMEMsgProc                                      */


/************************************************************************/
/*                                                                      */
/* RegisterClasses Function                                             */
/*                                                                      */
/* The following function registers all the classes of all the windows  */
/* associated with this application. The function returns an error code */
/* if unsuccessful, otherwise it returns 0.                             */
/*                                                                      */
/************************************************************************/

RegisterClasses(void)
{
     WNDCLASS  wndclass;    /* struct to define a window class              */

     strcpy(szAppName, "EATME");

     /* load WNDCLASS with window's characteristics                         */
     wndclass.style = CS_HREDRAW | CS_VREDRAW;   
     wndclass.lpfnWndProc = WndProc;
     /* Extra storage for Class and Window objects */
     wndclass.cbClsExtra = 0;
     wndclass.cbWndExtra = 0;
     wndclass.hInstance = hInst;
     wndclass.hIcon = LoadIcon(NULL, IDI_APPLICATION);
     wndclass.hCursor = LoadCursor(NULL, IDC_ARROW);
     /* Create brush for erasing background                                 */
     wndclass.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);
     wndclass.lpszMenuName = szAppName; /* Load Menu Resource       */
     wndclass.lpszClassName = szAppName;  /* Class Name is Window Name      */

     if(!RegisterClass(&wndclass))
          return(-1);


     return(0);
} /* End of RegisterClasses */


/************************************************************************/
/*  cwNumericValidate Function                                          */
/*                                                                      */
/*  Returns TRUE if the string is acceptable, otherwise returns FALSE   */
/*                                                                      */
/************************************************************************/

int cwNumericValidate(string)
char *string;
{
     int count;

     if(string[0] == 0x00)
          return(TRUE);

     for(count = 0; count <= (int)strlen(string)-1; count++)
          if(isdigit((int)string[count]) || (string[count] == '-' && count == 0))
               continue;
          else
               return(FALSE);

     return(TRUE);
} /* end of cwNumericValidate                                             */

/************************************************************************/
/*  CreateFormatString Function                                         */
/*                                                                      */
/*  creates a string to map the format of a user defined edit control   */
/*                                                                      */
/************************************************************************/

void CreateFormatString(outstring, instring, sw)
char *outstring;
char *instring;
int sw;
{
     int count;

     for(count = 0; count <= (int)strlen(instring); count++)
     {
          if(sw == CTRL)
          {  /* format the string to make a control mask                   */
               if(instring[count] == 0x20)
                    outstring[count] = '^';
               else if((instring[count] == 'X') || (instring[count] == 'x')
                 || (instring[count] == '9') || (instring[count] == '?'))
                    outstring[count] = 0x20;
               else
                    outstring[count] = instring[count];
          }  /* format the string to display in the edit control           */
          else if((instring[count] == 'X') || (instring[count] == 'x')
            || (instring[count] == '9') || (instring[count] == '?'))
               outstring[count] = 0x20;
          else
               outstring[count] = instring[count];
     }
     outstring[(count + 1)] = 0x00;
}


/************************************************************************/
/*  cwCenter Function                                                   */
/*                                                                      */
/*  centers a window based on the client area of its parent             */
/*                                                                      */
/************************************************************************/

void cwCenter(hWnd, top)
HWND hWnd;
int top;
{
     POINT pt;
     RECT swp;
     RECT rParent;
     int iwidth;
     int iheight;

     /* get the rectangles for the parent and the child                     */
     GetWindowRect(hWnd, &swp);
     GetWindowRect(hWndMain, &rParent);

     /* calculate the height and width for MoveWindow                       */
     iwidth = swp.right - swp.left;
     iheight = swp.bottom - swp.top;

     /* find the center point and convert to screen coordinates             */
     pt.x = (rParent.right - rParent.left) / 2;
     pt.y = (rParent.bottom - rParent.top) / 2;
     ClientToScreen(hWndMain, &pt);

     /* calculate the new x, y starting point                               */
     pt.x = pt.x - (iwidth / 2);
     pt.y = pt.y - (iheight / 2);

     /* top will adjust the window position, up or down                     */
     if(top)
          pt.y = pt.y + top;

     /* move the window                                                     */
     MoveWindow(hWnd, pt.x, pt.y, iwidth, iheight, FALSE);
}

/************************************************************************/
/*  required Function                                                   */
/*                                                                      */
/*  checks to see if a required edit field has been completed           */
/*  returns true if it has, false if it has not                         */
/*                                                                      */
/************************************************************************/

required(instring, format)
char *instring;
char *format;
{
     int count;

     if(format == NULL)
     {
          if(instring[0] == 0x00)
               return(FALSE);
     }
     else
     {
          char format_string[80];
          char display_string[80];

          CreateFormatString(format_string, format, CTRL);
          CreateFormatString(display_string, format, DISPLAY);

          for(count = 0; count <= (int)strlen(instring); count++)
          {
               if((format_string[count] == display_string[count]) 
                 && (display_string[count] != 0x20))
                    continue;
               if((instring[count] == 0x20) && (format_string[count] != '^'))
                    return(FALSE);
          }
     }
     return(TRUE);
}



